---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.9.1
  creationTimestamp: null
  name: rke2configs.bootstrap.cluster.x-k8s.io
spec:
  group: bootstrap.cluster.x-k8s.io
  names:
    kind: RKE2Config
    listKind: RKE2ConfigList
    plural: rke2configs
    singular: rke2config
  scope: Namespaced
  versions:
  - name: v1alpha1
    schema:
      openAPIV3Schema:
        description: RKE2Config is the Schema for the rke2configs API
        properties:
          apiVersion:
            description: 'APIVersion defines the versioned schema of this representation
              of an object. Servers should convert recognized schemas to the latest
              internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources'
            type: string
          kind:
            description: 'Kind is a string value representing the REST resource this
              object represents. Servers may infer this from the endpoint the client
              submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds'
            type: string
          metadata:
            type: object
          spec:
            description: RKE2ConfigSpec defines the desired state of RKE2Config
            properties:
              agentConfig:
                description: AgentConfig specifies configuration for the agent nodes
                properties:
                  kubeProxyArgs:
                    description: KubeProxyArgs Customized flag for kube-proxy process
                    items:
                      type: string
                    type: array
                  kubeletArgs:
                    description: KubeletArgs Customized flag for kubelet process
                    items:
                      type: string
                    type: array
                  nodeLabels:
                    description: NodeLabels  Registering and starting kubelet with
                      set of labels
                    items:
                      type: string
                    type: array
                  nodeName:
                    description: NodeName Name of the Node
                    type: string
                  nodeTaints:
                    description: NodeTaints Registering kubelet with set of taints
                    items:
                      type: string
                    type: array
                  privateRegistry:
                    description: 'TODO: take in a object or secret and write to file.
                      this is not useful PrivateRegistry  registry configuration file
                      (default: "/etc/rancher/rke2/registries.yaml")'
                    type: string
                type: object
              deployRKE2Commands:
                description: DeployRKE2Commands enables to override commands that
                  are executed to setup rke2. It may be leveraged to deploy
                items:
                  type: string
                type: array
              files:
                description: Files specifies extra files to be passed to user_data
                  upon creation.
                items:
                  description: File defines the input for generating write_files in
                    cloud-init.
                  properties:
                    content:
                      description: Content is the actual content of the file.
                      type: string
                    contentFrom:
                      description: ContentFrom is a referenced source of content to
                        populate the file.
                      properties:
                        secret:
                          description: Secret represents a secret that should populate
                            this file.
                          properties:
                            key:
                              description: Key is the key in the secret's data map
                                for this value.
                              type: string
                            name:
                              description: Name of the secret in the RKE2BootstrapConfig's
                                namespace to use.
                              type: string
                          required:
                          - key
                          - name
                          type: object
                      required:
                      - secret
                      type: object
                    encoding:
                      description: Encoding specifies the encoding of the file contents.
                      enum:
                      - base64
                      - gzip
                      - gzip+base64
                      type: string
                    owner:
                      description: Owner specifies the ownership of the file, e.g.
                        "root:root".
                      type: string
                    path:
                      description: Path specifies the full path on disk where to store
                        the file.
                      type: string
                    permissions:
                      description: Permissions specifies the permissions to assign
                        to the file, e.g. "0640".
                      type: string
                  required:
                  - path
                  type: object
                type: array
              postRKE2Commands:
                description: PostRKE2Commands specifies extra commands to run after
                  rke2 setup runs
                items:
                  type: string
                type: array
              preRKE2Commands:
                description: PreRKE2Commands specifies extra commands to run before
                  rke2 setup runs
                items:
                  type: string
                type: array
              serverConfig:
                description: ServerConfig specifies configuration for the agent nodes
                properties:
                  advertiseAddress:
                    description: 'AdvertiseAddress IP address that apiserver uses
                      to advertise to members of the cluster (default: node-external-ip/node-ip)'
                    type: string
                  advertisePort:
                    description: 'AdvertisePort Port that apiserver uses to advertise
                      to members of the cluster (default: listen-port) (default: 0)'
                    type: string
                  bindAddress:
                    description: 'BindAddress rke2 bind address (default: 0.0.0.0)'
                    type: string
                  clusterCidr:
                    description: 'ClusterCidr  Network CIDR to use for pod IPs (default:
                      "10.42.0.0/16")'
                    type: string
                  clusterDNS:
                    description: 'ClusterDNS  Cluster IP for coredns service. Should
                      be in your service-cidr range (default: 10.43.0.10)'
                    type: string
                  clusterDomain:
                    description: 'ClusterDomain Cluster Domain (default: "cluster.local")'
                    type: string
                  disableComponents:
                    description: DisableComponents  specifies extra commands to run
                      before rke2 setup runs
                    items:
                      type: string
                    type: array
                  httpsListenPort:
                    description: 'HttpsListenPort HTTPS listen port (default: 6443)'
                    type: string
                  kubeAPIServerArg:
                    description: KubeAPIServerArgs is a customized flag for kube-apiserver
                      process
                    items:
                      type: string
                    type: array
                  kubeControllerManagerArgs:
                    description: KubeControllerManagerArgs is a customized flag for
                      kube-controller-manager process
                    items:
                      type: string
                    type: array
                  serviceCidr:
                    description: 'ServiceCidr Network CIDR to use for services IPs
                      (default: "10.43.0.0/16")'
                    type: string
                  tlsSan:
                    description: TLSSan Add additional hostname or IP as a Subject
                      Alternative Name in the TLS cert
                    items:
                      type: string
                    type: array
                type: object
              version:
                description: Version specifies the rke2 version
                type: string
            type: object
          status:
            description: RKE2ConfigStatus defines the observed state of RKE2Config
            properties:
              bootstrapData:
                format: byte
                type: string
              conditions:
                description: Conditions defines current service state of the RKE2Config.
                items:
                  description: Condition defines an observation of a Cluster API resource
                    operational state.
                  properties:
                    lastTransitionTime:
                      description: Last time the condition transitioned from one status
                        to another. This should be when the underlying condition changed.
                        If that is not known, then using the time when the API field
                        changed is acceptable.
                      format: date-time
                      type: string
                    message:
                      description: A human readable message indicating details about
                        the transition. This field may be empty.
                      type: string
                    reason:
                      description: The reason for the condition's last transition
                        in CamelCase. The specific API may choose whether or not this
                        field is considered a guaranteed API. This field may not be
                        empty.
                      type: string
                    severity:
                      description: Severity provides an explicit classification of
                        Reason code, so the users or machines can immediately understand
                        the current situation and act accordingly. The Severity field
                        MUST be set only when Status=False.
                      type: string
                    status:
                      description: Status of the condition, one of True, False, Unknown.
                      type: string
                    type:
                      description: Type of condition in CamelCase or in foo.example.com/CamelCase.
                        Many .condition.type values are consistent across resources
                        like Available, but because arbitrary conditions can be useful
                        (see .node.status.conditions), the ability to deconflict is
                        important.
                      type: string
                  required:
                  - lastTransitionTime
                  - status
                  - type
                  type: object
                type: array
              dataSecretName:
                description: DataSecretName is the name of the secret that stores
                  the bootstrap data script.
                type: string
              failureMessage:
                description: FailureMessage will be set on non-retryable errors
                type: string
              failureReason:
                description: FailureReason will be set on non-retryable errors
                type: string
              observedGeneration:
                description: ObservedGeneration is the latest generation observed
                  by the controller.
                format: int64
                type: integer
              ready:
                description: Ready indicates the BootstrapData field is ready to be
                  consumed
                type: boolean
            type: object
        type: object
    served: true
    storage: true
    subresources:
      status: {}
